// RndWnd1.cpp:     .
//

#include "stdafx.h"
#include "RndWnd.h"

// 
#define MAX_LOADSTRING			100
#define MAIN_WIN_SIZE			100
#define TRANSPARENT_COLOR		RGB(0,0,0)

enum AREA_STATE
{
	NONE,
	LEFT,
	RIGHT
};

//  :
HINSTANCE hInst;								//  
TCHAR szTitle[MAX_LOADSTRING];			//   
TCHAR szWindowClass[MAX_LOADSTRING];	//    
HMENU hMainMenu = NULL;						//  
GraphicsPath* g_pRightPath = NULL;		//    
GraphicsPath* g_pLeftPath = NULL;		//    
AREA_STATE g_AreaState = NONE;			//    

//   ,     :
ATOM	MyRegisterClass(HINSTANCE hInstance);
BOOL	InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

//   
int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	MSG msg;
	HACCEL hAccelTable;
	GdiplusStartupInput gdiplusStartupInput;
   ULONG_PTR           gdiplusToken;

	//   
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_RNDWND, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	//  GDI+
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);

	//   :
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_RNDWND));

	//   :
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	//  
	if (g_pRightPath != NULL)
		delete g_pRightPath;
	if (g_pLeftPath != NULL)
		delete g_pLeftPath;

	//  GDI+
	GdiplusShutdown(gdiplusToken);

	return (int) msg.wParam;
}

//
//  : MyRegisterClass()
//
//  :   .
//
//  :
//
//            ,  ,   
//        Win32,    RegisterClassEx'
//        Windows 95.      ,
//       ""     
//     .
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style				= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc		= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance			= hInstance;
	wcex.hIcon				= LoadIcon(hInstance, MAKEINTRESOURCE(IDC_RNDWND));
	wcex.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName		= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm			= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//    
void CreateAreas()
{
	//   
	REAL AreaOffset = 4.0;
	RectF AreaRect(AreaOffset, AreaOffset, MAIN_WIN_SIZE - 2*AreaOffset, MAIN_WIN_SIZE - 2*AreaOffset);
	REAL OffsetAngle = 180 * asin((AreaOffset/2) / (AreaRect.Width/2)) / 3.14159265f;

	//   
	g_pRightPath = new GraphicsPath();
	g_pRightPath->AddArc(AreaRect, OffsetAngle - 90, 180 - 2*OffsetAngle);
	g_pRightPath->CloseFigure();

	//   
	g_pLeftPath = new GraphicsPath();
	g_pLeftPath->AddArc(AreaRect, 90 + OffsetAngle, 180 - 2*OffsetAngle);
	g_pLeftPath->CloseFigure();
}

//
//   : InitInstance(HINSTANCE, int)
//
//   :       .
//
//   :
//
//                ,  
//               .
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance;

	//   
	hMainMenu = LoadMenu(hInstance, MAKEINTRESOURCE(IDC_RNDWND));

	//    ( WS_POPUP)   MAIN_WIN_SIZE
	hWnd = CreateWindowEx(WS_EX_LAYERED, szWindowClass, szTitle, WS_POPUP,
							    10, 10, MAIN_WIN_SIZE, MAIN_WIN_SIZE, NULL, NULL, hInstance, NULL);


   if (!hWnd)
   {
      return FALSE;
   }

	//      
	SetLayeredWindowAttributes(hWnd, TRANSPARENT_COLOR, 0, LWA_COLORKEY);

	//  
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

//   
void OnPaint(HDC hDC, RECT& ClRect)
{
	Graphics graph(hDC);

	//   
	SolidBrush brush(Color(150, 200, 200, 255));
	graph.FillEllipse(&brush, 0, 0, ClRect.right, ClRect.bottom);

	//   
	SolidBrush RightPathBrush(Color(200, 0, 0));
	if (g_AreaState == RIGHT)
		RightPathBrush.SetColor(Color(255, 0, 0));
	graph.FillPath(&RightPathBrush, g_pRightPath);

	//   
	SolidBrush LeftPathBrush(Color(0, 200, 0));
	if (g_AreaState == LEFT)
		LeftPathBrush.SetColor(Color(0, 255, 0));
	graph.FillPath(&LeftPathBrush, g_pLeftPath);
}

//
//  : WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  :      .
//
//  WM_COMMAND	-   
//  WM_PAINT	-  
//  WM_DESTROY	 -      .
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	static int iMouseCapture_xPos;
	static int iMouseCapture_yPos;

	switch (message)
	{
	//   
	case WM_CREATE:
			//    
			CreateAreas();
			return 0;
	//   
	case  WM_CONTEXTMENU:
		{
			//   
			int xPos = GET_X_LPARAM(lParam); 
			int yPos = GET_Y_LPARAM(lParam);

			//  
			::TrackPopupMenuEx(::GetSubMenu(hMainMenu, 0), TPM_LEFTALIGN | TPM_TOPALIGN, xPos, yPos, hWnd, NULL);
		}
		return 0;
	//     
	case WM_LBUTTONDOWN:
		{
			//   
			int xPos = GET_X_LPARAM(lParam); 
			int yPos = GET_Y_LPARAM(lParam);
			//  
			iMouseCapture_xPos = xPos;
			iMouseCapture_yPos = yPos;
			SetCapture(hWnd);
		}
		return 0;
	//  
	case WM_MOUSEMOVE:
		{
			//   
			int xPos = GET_X_LPARAM(lParam); 
			int yPos = GET_Y_LPARAM(lParam);

			if (GetCapture() == hWnd)
			{//  
				//  
				RECT WndRect;
				::GetWindowRect(hWnd, &WndRect);
				int iOffset_xPos = xPos - iMouseCapture_xPos;
				int iOffset_yPos = yPos - iMouseCapture_yPos;
				::SetWindowPos(hWnd, NULL, WndRect.left + iOffset_xPos, WndRect.top + iOffset_yPos, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}
			else
			{//   
				if (g_pRightPath->IsVisible(xPos, yPos))
				{//    
					if (g_AreaState != RIGHT)
					{
						g_AreaState = RIGHT;
						//  
						InvalidateRect(hWnd, NULL, TRUE);
						UpdateWindow(hWnd);
						//       
						TRACKMOUSEEVENT trkmsev;
						trkmsev.cbSize = sizeof(trkmsev);
						trkmsev.dwFlags = TME_LEAVE;
						trkmsev.hwndTrack = hWnd;
						TrackMouseEvent(&trkmsev);
					}
				}
				else if (g_pLeftPath->IsVisible(xPos, yPos))
				{//    
					if (g_AreaState != LEFT)
					{
						g_AreaState = LEFT;
						//  
						InvalidateRect(hWnd, NULL, TRUE);
						UpdateWindow(hWnd);
						//       
						TRACKMOUSEEVENT trkmsev;
						trkmsev.cbSize = sizeof(trkmsev);
						trkmsev.dwFlags = TME_LEAVE;
						trkmsev.hwndTrack = hWnd;
						TrackMouseEvent(&trkmsev);
					}
				}
				else
				{//   
					if (g_AreaState != NONE)
					{
						g_AreaState = NONE;
						//  
						InvalidateRect(hWnd, NULL, TRUE);
						UpdateWindow(hWnd);
						//       
						TRACKMOUSEEVENT trkmsev;
						trkmsev.cbSize = sizeof(trkmsev);
						trkmsev.dwFlags = TME_LEAVE | TME_CANCEL;
						trkmsev.hwndTrack = hWnd;
						TrackMouseEvent(&trkmsev);
					}
				}
			}
		}
		return 0;
	//    
	case WM_LBUTTONUP:
		if (GetCapture() == hWnd)
		{//  
			//  
			::ReleaseCapture();
		}
		return 0;
	//     
	case WM_MOUSELEAVE:
		if (g_AreaState != NONE)
		{
			g_AreaState = NONE;
			//  
			InvalidateRect(hWnd, NULL, TRUE);
			UpdateWindow(hWnd);
		}
		return 0;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		//    :
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hDC = NULL;
			HDC hCompDC = NULL;
			RECT ClRect;
			HBITMAP hCompBitmap = NULL;
			HBITMAP hOldBitmap = NULL;

			hDC = BeginPaint(hWnd, &ps);

			//    
			hCompDC = CreateCompatibleDC(hDC);
			GetClientRect(hWnd, &ClRect);
			hCompBitmap = CreateCompatibleBitmap(hDC, ClRect.right, ClRect.bottom);
			hOldBitmap = (HBITMAP)SelectObject(hCompDC, hCompBitmap);
			//     
			HBRUSH hTransBrush = CreateSolidBrush(TRANSPARENT_COLOR);
			FillRect(hCompDC, &ClRect, hTransBrush);
			DeleteObject(hTransBrush);
			//  
			OnPaint(hCompDC, ClRect);

			//    
			BitBlt(hDC, 0, 0, ClRect.right, ClRect.bottom, hCompDC, 0, 0, SRCCOPY);
			//  
			SelectObject(hCompDC, hOldBitmap);
			DeleteObject(hCompBitmap);
			DeleteDC(hCompDC);

			EndPaint(hWnd, &ps);
		}
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//     " ".
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
